package com.logicbig.example;

import java.beans.PropertyEditor;
import java.beans.PropertyEditorManager;
import java.beans.PropertyEditorSupport;


public class ExplicitPropEditorRegistration {

    public static void main (String[] args) {
        //auto discovering editor
        PropertyEditor editor = PropertyEditorManager.findEditor(User.class);
        System.out.println("Auto discovered: "+editor.getClass().getSimpleName());

        //auto explicitly registering a specific editor
         PropertyEditorManager.registerEditor(User.class, UserEditor2.class);
        editor = PropertyEditorManager.findEditor(User.class);
        System.out.println("Explicitly registered: "+editor.getClass().getSimpleName());

        editor.setAsText("Joe");
        System.out.println(editor.getValue());
    }

    public static class UserEditor extends PropertyEditorSupport {

        @Override
        public String getAsText () {
            User user = (User) getValue();
            return user.getName();
        }

        @Override
        public void setAsText (String s) {
            User user = new User();
            user.setName(s);
            setValue(user);
        }
    }

    public static class UserEditor2 extends PropertyEditorSupport {

        @Override
        public String getAsText () {
            User user = (User) getValue();
            return user.getName();
        }

        @Override
        public void setAsText (String s) {
            User user = new User();
            user.setName(s);
            setValue(user);
        }
    }

    public static class User {
        private String name;


        public String getName () {
            return name;
        }

        public void setName (String name) {
            this.name = name;
        }

        @Override
        public String toString () {
            return "User{" +
                                "name='" + name + '\'' +
                                '}';
        }
    }
}